/*
iadn
http://www.iadn.narod.ru
iadn@bk.ru
*/

#include<menuet/os.h>
#include <kosgl.h> //TinyGL
#include <string.h>
#include <math.h>

#include "SysCall.h"
#include "ProcessTab.h"
#include "bmp.h"

int Fps (long x, long y);
extern "C"{
void app_main(void);
}

struct {
	   int x,y;
	   int dx,dy;
	   } win;

#define KEY_ESC       1
#define KEY_F     	 33

#define KEY_L     	 38
#define KEY_P     	 25
#define KEY_S     	 31
#define KEY_T     	 20

char *title1 = "TinyGL in KolibriOS";
char *title2 = "F full screen, T texture, S/L/P render mode";
char *title3 = "ESC - exit";
char *fps    = "FPS:";

unsigned char FullScreen = 0;
unsigned char skin = 3;
unsigned char Texture = 1;

process_table_entry_* pri;
float angle = 0.0;
KOSGLContext cgl;

static GLuint* TexObj;

GLfloat lightpos[4] = {0.0, 2.5, 0.0, 1.0};
GLfloat lightdirect[3] = {0.0, 0.0, 0.0};


#define DIM    9
#define DIM2   (1.0/(2.0*DIM))
#define T      1

float rad[2*DIM+1][2*DIM];

void DrawPlan()
{  
  float v1,v2,v3,v4, ang;
  int i,j,n;
  
  n = 1;
  i = 0;
  j = 0;
  
  glLoadIdentity();
  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  glTranslatef(0.0, 0.0,-30.0);            
  glRotatef(30.0, 1.0, 0.0, 0.0);          
  glRotatef(angle, 0.0, 1.0, 0.0); 
  
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);                   
  glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, lightdirect);          
  
    for (i = -DIM; i<DIM; i++)
    for (j = -DIM; j<=DIM; j++)
     {
       if (n ==1)
         {
           glColor3f(200.0/255.0, 40.0/255.0, 240.0/255.0); 
           n = 0;
          }
       else
         {
           glColor3f(0.8, 0.8, 0.8);
           n =1;          
         }

		ang = 0.25*angle;
		v1 = 0.7*sin(rad[i+DIM][j+DIM+1]-ang);
		v2 = 0.7*sin(rad[i+DIM+1][j+DIM+1]-ang);
		v3 = 0.7*sin(rad[i+DIM+1][j+DIM]-ang);
		v4 = 0.7*sin(rad[i+DIM][j+DIM]-ang);
		
		glBegin(GL_QUADS);
		  glTexCoord2f(DIM2*(DIM+i), DIM2*(DIM+j));
          glVertex3f ((float)i, v1, (float)j+1);
          glTexCoord2f(DIM2*(DIM+i+1), DIM2*(DIM+j));
          glVertex3f ((float)i+1, v2, (float)j+1);
          glTexCoord2f(DIM2*(DIM+i+1), DIM2*(DIM+j-1));
          glVertex3f ((float)i+1, v3, (float)j);
          glTexCoord2f(DIM2*(DIM+i), DIM2*(DIM+j-1));
          glVertex3f ((float)i, v4, (float)j);
        glEnd(); 
     }  

  kosglSwapBuffers(); 
 } 

void reshape()
{   
   __menuet__get_process_table((process_table_entry*)pri,-1);
   glViewport(0, 0, pri->winx_size, pri->winy_size-20);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(35.0, (GLfloat)pri->winx_size/pri->winy_size, 1.0, 300.0);
   glMatrixMode(GL_MODELVIEW);
   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );     
}

void disabletgl()
{
	kosglDestroyContext(cgl); 
	delete pri;
}  

void Title()
{
     __menuet__write_text(430,8,0x10ffffff,fps,strlen(fps));
     __menuet__write_text(8,8,0x10ffffff,title1,strlen(title1));
	 __menuet__write_text(150,8,0x00ffffff,title2,strlen(title2));
     __menuet__write_text(600,8,0x00ffffff,title3,strlen(title3));
}

void draw_window(void)
{
	// start redraw
	__menuet__window_redraw(1);
	// define&draw window
	__menuet__define_window(win.x,win.y,win.dx,win.dy,TYPEWIN(0,0,0,1,skin,0,0,0),0,0);
    // end redraw
    __menuet__window_redraw(2);
    // display string
    Title();
}

void app_main(void)          
{
	 
  win.x = 100;
  win.y = 100;
  win.dx = 525;
  win.dy = 300;

  draw_window();
  
  cgl = kosglCreateContext( 0, 0);
  kosglMakeCurrent( 0, 20, win.dx, win.dy-20, cgl);
  
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();  

  glClearColor (0, 0.0, 0.0, 1.0); 
  
  glEnable(GL_LIGHTING);
  glLightf(GL_LIGHT0, GL_SPOT_EXPONENT, 0.0);
  glLightf(GL_LIGHT0, GL_SPOT_CUTOFF, 180.0);
  glEnable(GL_LIGHT0);
  
  glNormal3f(0.0, 1.0, 0.0);
  
  glEnable(GL_COLOR_MATERIAL);
  glEnable(GL_NORMALIZE);
  
  glClearDepth(1.0);
  glEnable( GL_CULL_FACE );
  glEnable(GL_DEPTH_TEST);
  
  int width, height;
  unsigned char* texture;
  LoadFileBMP( "./logio.bmp", &texture, &width, &height, true );
  
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);

  glGenTextures(1, TexObj);
  glBindTexture(GL_TEXTURE_2D, *TexObj);
  glTexImage2D(GL_TEXTURE_2D, 0, 3, width, height, 0,  GL_RGB, GL_UNSIGNED_BYTE, texture);
    
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glBindTexture(GL_TEXTURE_2D, *TexObj);
  glEnable(GL_TEXTURE_2D);
  
  for (int i = -DIM; i<DIM; i++)
  for (int j = -DIM; j<=DIM; j++)
     {
       rad[i+DIM][j+DIM+1] = T*sqrt(i*i+(j+1)*(j+1));
       rad[i+DIM+1][j+DIM+1] = T*sqrt((i+1)*(i+1)+(j+1)*(j+1));
       rad[i+DIM+1][j+DIM] = T*sqrt((i+1)*(i+1)+j*j);
       rad[i+DIM][j+DIM] = T*sqrt(i*i+j*j);
     }   

  pri=new process_table_entry_;
  SysCall(66,1,1);
  
  reshape();

do{

 angle += 0.001 + 0.08*Fps (460,8);
 
 DrawPlan();
 				
		  switch(SysCall(11))
		      {
		          case 1: draw_window();				  	   	  
				  	   	  reshape();
				  	   	  break;
				  	   	  
		          case 2: 		          
		          	   switch(__menuet__getkey()){

						   case KEY_F:
                                    if(!FullScreen){									 
									 skin=0;
									 SysCall(67,0,0,SysCall(14)>>16,SysCall(14)&0xffff);
									 draw_window();
									 reshape();
									 FullScreen = 1;
									}
									else{
									 skin=3;
									 draw_window();								 
									 SysCall(67,win.x,win.y,win.dx,win.dy);
									 reshape();
									 FullScreen = 0;
									};
						  			break;

						   case KEY_T:
                                    if(Texture){
												glDisable(GL_TEXTURE_2D);
												Texture = 0;
												}
									else        {
										 		glEnable(GL_TEXTURE_2D);
												Texture = 1;
										        }
						  			break;
						  			
						   case KEY_S:
                                    glPolygonMode(GL_FRONT,GL_FILL);
						  			break;
						   
						   case KEY_L:
                                    glPolygonMode(GL_FRONT,GL_LINE);
						  			break;
						   
						   case KEY_P:
                                    glPolygonMode(GL_FRONT,GL_POINT);
						  			break;
									  		          
                           case KEY_ESC: disabletgl();
						  				 return;}
						  				 break;
						  			
			  	  case 3: disabletgl();
						  return;
		      }
}while(1);
}
